<script lang="ts">
    import Button from '$components/Button.svelte'
    import type District from '$models/District'
    import type { Stargate } from '$utils/API/Planet.type'
    import { get, post } from '$lib/fetch'
    import UnitSelector from './UnitSelector.svelte'
    import { pushSuccess } from '$lib/success'
    import { pushError } from '$lib/errors'
    import BaseError from '$lib/errors/Errors/BaseError'
    import SelectedPanel from './SelectedPanel.svelte'

    export let stargate: Stargate
    export let district: District

    let units = district.units

    let distance: number

    let sendedUnits = {
        AttackShip: 0,
        DefenseShip: 0,
        PolyvalentShip: 0,
        Speeder: 0
    }

    let time: number
    $: time =
        (distance /
            Object.keys(sendedUnits).reduce((speed: number, name: string) => {
                let unit = $units.find(({ type }) => type === name)
                if (sendedUnits[name] > 0 && speed < unit.speed) {
                    return unit.speed
                }
                return speed
            }, 0)) *
        60

    $: get('/api/planet/getDistanceFromDistrict', {
        from: district.id,
        x: stargate.x,
        y: stargate.y
    }).then(res => (distance = res.res))

    $: nbUnits = Object.keys(sendedUnits).reduce(
        (nb: number, name: string) => nb + sendedUnits[name],
        0
    )

    $: eleriumConsumption = distance * nbUnits * 20
    $: pasteConsumption = Math.round(time * nbUnits * 5)

    const select = (type: string, value: number) => {
        sendedUnits[type] = value
    }

    const send = () => {
        post(`/api/districts/${district.id}/sendFleet`, {
            x: stargate.x,
            y: stargate.y,
            units: Object.keys(sendedUnits).reduce(
                (units: Record<string, number>, name: string) => {
                    if (sendedUnits[name] > 0) {
                        units[name] = sendedUnits[name]
                    }
                    return units
                },
                {}
            )
        })
            .then(res => {
                pushSuccess(`You have send the fleet, it will arrived in ${res.res.travelTime}min`)
            })
            .catch(() => pushError(new BaseError("You haven't enough resources")))
    }
</script>

<SelectedPanel on:cancel>
    <h2>
        {stargate.color} stargate <span class={stargate.color} />
    </h2>
    {#if stargate.owner}
        <div class="owner">
            <h3>Owner</h3>
            <p>
                This stargate is occupied by <strong>{stargate.owner}</strong> from the
                <strong>{stargate.faction}</strong>.
            </p>

            <h3>Units in the stargate</h3>
            <table class="table-auto w-full">
                <thead>
                    <tr>
                        <th>Type</th>
                        <th class="text-right">Number</th>
                    </tr>
                </thead>
                <tbody>
                    {#each Object.keys(stargate.units) as type}
                        <tr>
                            <td>{type}</td>
                            <td>{stargate.units[type]}</td>
                        </tr>
                    {/each}
                </tbody>
            </table>
        </div>
    {/if}
    <h2>Send a fleet</h2>
    <div>
        {#each $units as unit}
            <UnitSelector {unit} on:select={event => select(unit.type, event.detail)} />
        {/each}
        <div>
            <h3>Cost</h3>
            <table class="table-auto w-full">
                <thead>
                    <tr>
                        <th>Elerium</th>
                        <th class="text-right">Paste</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>{eleriumConsumption ? eleriumConsumption : 0}</td>
                        <td>{pasteConsumption ? pasteConsumption : 0}</td>
                    </tr>
                </tbody>
            </table>
        </div>
        <Button on:click={send}>Send</Button>
    </div>
</SelectedPanel>

<style lang="postcss">
    h2 {
        @apply text-center text-xl font-bold;

        span {
            @apply inline-block w-4 h-4 absolute ml-2;

            &.red {
                @apply bg-tile-red;
            }
            &.yellow {
                @apply bg-tile-yellow;
            }
            &.orange {
                @apply bg-tile-orange;
            }
            &.violet {
                @apply bg-tile-violet;
            }
        }
    }

    h3 {
        @apply text-xl font-semibold px-1 mb-1
        flex items-center gap-x-1
        bg-gradient-to-r from-fuchsia-200 to-indigo-200
        dark:from-fuchsia-900 dark:to-indigo-900;
        clip-path: polygon(calc(100% - 0.1rem) 0, 100% 100%, 0.1rem 100%, 0 0);
    }

    thead {
        @apply text-left text-trueGray-500 dark:text-trueGray-400;
    }

    tbody > tr {
        @apply hover:bg-trueGray-200 hover:dark:bg-trueGray-800 transition-colors duration-100 ease-out;
    }

    .owner {
        @apply space-y-4;
    }
</style>
